diff --git a/gcc/testsuite/gcc.dg/plugin/diagnostic-path-format-inline-events-3.c b/gcc/testsuite/gcc.dg/plugin/diagnostic-path-format-inline-events-3.c
index 969a060..5e7b099 100644
--- a/gcc/testsuite/gcc.dg/plugin/diagnostic-path-format-inline-events-3.c
+++ b/gcc/testsuite/gcc.dg/plugin/diagnostic-path-format-inline-events-3.c
@@ -1,5 +1,5 @@
 /* { dg-do compile } */
-/* { dg-options "-fdiagnostics-path-format=inline-events -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers" } */
+/* { dg-options "-fdiagnostics-path-format=inline-events -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-show-caret" } */
 
 /* Verify the interaction of inline-events with line numbers.  */
 
@@ -16,105 +16,108 @@ void wrapped_free (void *ptr)
 {
   free (ptr); /* { dg-warning "double-free of 'ptr' \\\[CWE-415\\]" } */
   /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test': events 1-2
-     |
-     |   NN | {
-     |      | ^
-     |      | |
-     |      | (1) entering 'test'
-     |   NN |   boxed_int *obj = make_boxed_int (i);
-     |      |                    ~~~~~~~~~~~~~~~~~~
-     |      |                    |
-     |      |                    (2) calling 'make_boxed_int'
-     |
-     +--> 'make_boxed_int': events 3-4
+    |
+    |   NN | {
+    |      | ^
+    |      | |
+    |      | (1) entering 'test'
+    |   NN |   boxed_int *obj = make_boxed_int (i);
+    |      |                    ~~~~~~~~~~~~~~~~~~
+    |      |                    |
+    |      |                    (2) calling 'make_boxed_int'
+    |
+    +--> 'make_boxed_int': events 3-4
+           |
+           |   NN | {
+           |      | ^
+           |      | |
+           |      | (3) entering 'make_boxed_int'
+           |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
+           |      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+           |      |                                    |
+           |      |                                    (4) calling 'wrapped_malloc'
+           |
+           +--> 'wrapped_malloc': events 5-6
                   |
                   |   NN | {
                   |      | ^
                   |      | |
-                  |      | (3) entering 'make_boxed_int'
-                  |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
-                  |      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-                  |      |                                    |
-                  |      |                                    (4) calling 'wrapped_malloc'
+                  |      | (5) entering 'wrapped_malloc'
+                  |   NN |   return malloc (size);
+                  |      |          ~~~~~~~~~~~~~
+                  |      |          |
+                  |      |          (6) calling 'malloc'
                   |
-                  +--> 'wrapped_malloc': events 5-6
-                               |
-                               |   NN | {
-                               |      | ^
-                               |      | |
-                               |      | (5) entering 'wrapped_malloc'
-                               |   NN |   return malloc (size);
-                               |      |          ~~~~~~~~~~~~~
-                               |      |          |
-                               |      |          (6) calling 'malloc'
-                               |
-     <-------------------------+
-     |
+    <-------------+
+    |
   'test': event 7
-     |
-     |   NN |   free_boxed_int (obj);
-     |      |   ^~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (7) calling 'free_boxed_int'
-     |
-     +--> 'free_boxed_int': events 8-9
+    |
+    |   NN |   free_boxed_int (obj);
+    |      |   ^~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (7) calling 'free_boxed_int'
+    |
+    +--> 'free_boxed_int': events 8-9
+           |
+           |   NN | {
+           |      | ^
+           |      | |
+           |      | (8) entering 'free_boxed_int'
+           |   NN |   wrapped_free (bi);
+           |      |   ~~~~~~~~~~~~~~~~~
+           |      |   |
+           |      |   (9) calling 'wrapped_free'
+           |
+           +--> 'wrapped_free': events 10-11
                   |
                   |   NN | {
                   |      | ^
                   |      | |
-                  |      | (8) entering 'free_boxed_int'
-                  |   NN |   wrapped_free (bi);
-                  |      |   ~~~~~~~~~~~~~~~~~
+                  |      | (10) entering 'wrapped_free'
+                  |   NN |   free (ptr);
+                  |      |   ~~~~~~~~~~
                   |      |   |
-                  |      |   (9) calling 'wrapped_free'
+                  |      |   (11) calling 'free'
                   |
-                  +--> 'wrapped_free': events 10-11
-                              |
-                              |   NN | {
-                              |      | ^
-                              |      | |
-                              |      | (10) entering 'wrapped_free'
-                              |   NN |   free (ptr);
-                              |      |   ~~~~~~~~~~
-                              |      |   |
-                              |      |   (11) calling 'free'
-                              |
-     <------------------------+
-     |
+    <-------------+
+    |
   'test': event 12
-     |
-     | (12): calling 'missing_location'
-     |
+    |
+    |cc1:
+    | (12): calling 'missing_location'
+    |
   'test': event 13
-     |
-     |   NN |   free_boxed_int (obj);
-     |      |   ^~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (13) calling 'free_boxed_int'
-     |
-     +--> 'free_boxed_int': events 14-15
+    |
+    |   NN |   free_boxed_int (obj);
+    |      |   ^~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (13) calling 'free_boxed_int'
+    |
+    +--> 'free_boxed_int': events 14-15
+           |
+           |   NN | {
+           |      | ^
+           |      | |
+           |      | (14) entering 'free_boxed_int'
+           |   NN |   wrapped_free (bi);
+           |      |   ~~~~~~~~~~~~~~~~~
+           |      |   |
+           |      |   (15) calling 'wrapped_free'
+           |
+           +--> 'wrapped_free': events 16-17
                   |
                   |   NN | {
                   |      | ^
                   |      | |
-                  |      | (14) entering 'free_boxed_int'
-                  |   NN |   wrapped_free (bi);
-                  |      |   ~~~~~~~~~~~~~~~~~
+                  |      | (16) entering 'wrapped_free'
+                  |   NN |   free (ptr);
+                  |      |   ~~~~~~~~~~
                   |      |   |
-                  |      |   (15) calling 'wrapped_free'
+                  |      |   (17) calling 'free'
                   |
-                  +--> 'wrapped_free': events 16-17
-                              |
-                              |   NN | {
-                              |      | ^
-                              |      | |
-                              |      | (16) entering 'wrapped_free'
-                              |   NN |   free (ptr);
-                              |      |   ~~~~~~~~~~
-                              |      |   |
-                              |      |   (17) calling 'free'
-                              |
      { dg-end-multiline-output "" } */
 }
 
diff --git a/gcc/testsuite/gcc.dg/plugin/diagnostic-test-paths-2.c b/gcc/testsuite/gcc.dg/plugin/diagnostic-test-paths-2.c
index 9695fcb..391aeb9 100644
--- a/gcc/testsuite/gcc.dg/plugin/diagnostic-test-paths-2.c
+++ b/gcc/testsuite/gcc.dg/plugin/diagnostic-test-paths-2.c
@@ -35,24 +35,22 @@ make_a_list_of_random_ints_badly(PyObject *self,
   /* { dg-begin-multiline-output "" }
    29 |     PyList_Append(list, item);
       |     ^~~~~~~~~~~~~~~~~~~~~~~~~
-     { dg-end-multiline-output "" } */
-  /* { dg-begin-multiline-output "" }
   'make_a_list_of_random_ints_badly': events 1-3
-                   |
-                   |   25 |   list = PyList_New(0);
-                   |      |          ^~~~~~~~~~~~~
-                   |      |          |
-                   |      |          (1) when 'PyList_New' fails, returning NULL
-                   |   26 | 
-                   |   27 |   for (i = 0; i < count; i++) {
-                   |      |   ~~~     
-                   |      |   |
-                   |      |   (2) when 'i < count'
-                   |   28 |     item = PyLong_FromLong(random());
-                   |   29 |     PyList_Append(list, item);
-                   |      |     ~~~~~~~~~~~~~~~~~~~~~~~~~
-                   |      |     |
-                   |      |     (3) when calling 'PyList_Append', passing NULL from (1) as argument 1
-                   |
+    |
+    |   25 |   list = PyList_New(0);
+    |      |          ^~~~~~~~~~~~~
+    |      |          |
+    |      |          (1) when 'PyList_New' fails, returning NULL
+    |   26 | 
+    |   27 |   for (i = 0; i < count; i++) {
+    |      |   ~~~     
+    |      |   |
+    |      |   (2) when 'i < count'
+    |   28 |     item = PyLong_FromLong(random());
+    |   29 |     PyList_Append(list, item);
+    |      |     ~~~~~~~~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (3) when calling 'PyList_Append', passing NULL from (1) as argument 1
+    |
      { dg-end-multiline-output "" } */
 }
diff --git a/gcc/tree-diagnostic-path.cc b/gcc/tree-diagnostic-path.cc
index 09c46f3..d044152 100644
--- a/gcc/tree-diagnostic-path.cc
+++ b/gcc/tree-diagnostic-path.cc
@@ -156,11 +156,14 @@ class path_summary
       /* Emit a span indicating the filename (and line/column) if the
 	 line has changed relative to the last call to
 	 diagnostic_show_locus.  */
-      expanded_location exploc
-	= linemap_client_expand_location_to_spelling_point
+      if (dc->show_caret)
+	{
+	  expanded_location exploc
+	    = linemap_client_expand_location_to_spelling_point
 	    (initial_loc, LOCATION_ASPECT_CARET);
-      if (exploc.file != LOCATION_FILE (dc->last_location))
-	dc->start_span (dc, exploc);
+	  if (exploc.file != LOCATION_FILE (dc->last_location))
+	    dc->start_span (dc, exploc);
+	}
 
       /* If we have an UNKNOWN_LOCATION (or BUILTINS_LOCATION) as the
 	 primary location for an event, diagnostic_show_locus won't print
@@ -300,25 +303,7 @@ path_summary::print (diagnostic_context *dc, bool show_depths) const
 {
   pretty_printer *pp = dc->printer;
 
-  auto_vec<int> name_lengths;
-
-  /* Populate name_lengths.  */
-  {
-    pretty_printer *tmp_pp = pp->clone ();
-    pp_show_color (tmp_pp) = 0;
-    int i;
-    event_range *range;
-    FOR_EACH_VEC_ELT (m_ranges, i, range)
-      {
-	print_fndecl (tmp_pp, range->m_fndecl, false);
-	/* We want the length of the quoted decl in characters, not in bytes.
-	   For now, we get the length of the unquoted decl (in bytes), hope
-	   it's ASCII, and add 2 for the quotes.  */
-	name_lengths.safe_push (strlen (pp_formatted_text (tmp_pp)) + 2);
-	pp_clear_output_area (tmp_pp);
-      }
-    delete tmp_pp;
-  }
+  const int per_frame_indent = 2;
 
   const char *const line_color = "path";
   const char *start_line_color
@@ -365,11 +350,9 @@ path_summary::print (diagnostic_context *dc, bool show_depths) const
 	pp_printf (pp, " (depth %i)", range->m_stack_depth);
       pp_newline (pp);
 
-      int midpoint = name_lengths[i] / 2;
-
       /* Print a run of events.  */
       {
-	write_indent (pp, cur_indent + midpoint);
+	write_indent (pp, cur_indent + per_frame_indent);
 	pp_string (pp, start_line_color);
 	pp_string (pp, "|");
 	pp_string (pp, end_line_color);
@@ -379,7 +362,7 @@ path_summary::print (diagnostic_context *dc, bool show_depths) const
 	char *prefix;
 	{
 	  pretty_printer tmp_pp;
-	  write_indent (&tmp_pp, cur_indent + midpoint);
+	  write_indent (&tmp_pp, cur_indent + per_frame_indent);
 	  pp_string (&tmp_pp, start_line_color);
 	  pp_string (&tmp_pp, "|");
 	  pp_string (&tmp_pp, end_line_color);
@@ -390,7 +373,7 @@ path_summary::print (diagnostic_context *dc, bool show_depths) const
 	range->print (dc);
 	pp_set_prefix (pp, saved_prefix);
 
-	write_indent (pp, cur_indent + midpoint);
+	write_indent (pp, cur_indent + per_frame_indent);
 	pp_string (pp, start_line_color);
 	pp_string (pp, "|");
 	pp_string (pp, end_line_color);
@@ -410,20 +393,19 @@ path_summary::print (diagnostic_context *dc, bool show_depths) const
 		 "     <------------ +\n"
 		 "     |\n".  */
 
-	      int next_midpoint = name_lengths[i + 1] / 2;
-
 	      gcc_assert (vbar_column_for_depth.get
 			  (next_range->m_stack_depth));
 
 	      int vbar_for_next_frame
 		= *vbar_column_for_depth.get (next_range->m_stack_depth);
 
-	      int indent_for_next_frame = vbar_for_next_frame - next_midpoint;
+	      int indent_for_next_frame
+		= vbar_for_next_frame - per_frame_indent;
 	      write_indent (pp, vbar_for_next_frame);
 	      pp_string (pp, start_line_color);
 	      pp_character (pp, '<');
-	      for (int i = indent_for_next_frame + next_midpoint;
-		   i < cur_indent + midpoint - 1; i++)
+	      for (int i = indent_for_next_frame + per_frame_indent;
+		   i < cur_indent + per_frame_indent - 1; i++)
 		pp_character (pp, '-');
 	      pp_character (pp, '+');
 	      pp_string (pp, end_line_color);
@@ -442,8 +424,8 @@ path_summary::print (diagnostic_context *dc, bool show_depths) const
 	      gcc_assert (range->m_stack_depth != EMPTY);
 	      gcc_assert (range->m_stack_depth != DELETED);
 	      vbar_column_for_depth.put (range->m_stack_depth,
-					 cur_indent + midpoint);
-	      cur_indent += midpoint;
+					 cur_indent + per_frame_indent);
+	      cur_indent += per_frame_indent;
 	    }
 
 	}
@@ -651,54 +633,54 @@ test_interprocedural_path_1 (pretty_printer *event_pp)
   summary.print (&dc, true);
   ASSERT_STREQ
     ("  `test': events 1-2 (depth 0)\n"
-     "     |\n"
-     "     | (1): entering `test'\n"
-     "     | (2): calling `make_boxed_int'\n"
-     "     |\n"
-     "     +--> `make_boxed_int': events 3-4 (depth 1)\n"
+     "    |\n"
+     "    | (1): entering `test'\n"
+     "    | (2): calling `make_boxed_int'\n"
+     "    |\n"
+     "    +--> `make_boxed_int': events 3-4 (depth 1)\n"
+     "           |\n"
+     "           | (3): entering `make_boxed_int'\n"
+     "           | (4): calling `wrapped_malloc'\n"
+     "           |\n"
+     "           +--> `wrapped_malloc': events 5-6 (depth 2)\n"
      "                  |\n"
-     "                  | (3): entering `make_boxed_int'\n"
-     "                  | (4): calling `wrapped_malloc'\n"
+     "                  | (5): entering `wrapped_malloc'\n"
+     "                  | (6): calling malloc\n"
      "                  |\n"
-     "                  +--> `wrapped_malloc': events 5-6 (depth 2)\n"
-     "                               |\n"
-     "                               | (5): entering `wrapped_malloc'\n"
-     "                               | (6): calling malloc\n"
-     "                               |\n"
-     "     <-------------------------+\n"
-     "     |\n"
+     "    <-------------+\n"
+     "    |\n"
      "  `test': events 7-8 (depth 0)\n"
-     "     |\n"
-     "     | (7): returning to `test'\n"
-     "     | (8): calling `free_boxed_int'\n"
-     "     |\n"
-     "     +--> `free_boxed_int': events 9-10 (depth 1)\n"
+     "    |\n"
+     "    | (7): returning to `test'\n"
+     "    | (8): calling `free_boxed_int'\n"
+     "    |\n"
+     "    +--> `free_boxed_int': events 9-10 (depth 1)\n"
+     "           |\n"
+     "           | (9): entering `free_boxed_int'\n"
+     "           | (10): calling `wrapped_free'\n"
+     "           |\n"
+     "           +--> `wrapped_free': events 11-12 (depth 2)\n"
      "                  |\n"
-     "                  | (9): entering `free_boxed_int'\n"
-     "                  | (10): calling `wrapped_free'\n"
+     "                  | (11): entering `wrapped_free'\n"
+     "                  | (12): calling free\n"
      "                  |\n"
-     "                  +--> `wrapped_free': events 11-12 (depth 2)\n"
-     "                              |\n"
-     "                              | (11): entering `wrapped_free'\n"
-     "                              | (12): calling free\n"
-     "                              |\n"
-     "     <------------------------+\n"
-     "     |\n"
+     "    <-------------+\n"
+     "    |\n"
      "  `test': events 13-14 (depth 0)\n"
-     "     |\n"
-     "     | (13): returning to `test'\n"
-     "     | (14): calling `free_boxed_int'\n"
-     "     |\n"
-     "     +--> `free_boxed_int': events 15-16 (depth 1)\n"
-     "                  |\n"
-     "                  | (15): entering `free_boxed_int'\n"
-     "                  | (16): calling `wrapped_free'\n"
+     "    |\n"
+     "    | (13): returning to `test'\n"
+     "    | (14): calling `free_boxed_int'\n"
+     "    |\n"
+     "    +--> `free_boxed_int': events 15-16 (depth 1)\n"
+     "           |\n"
+     "           | (15): entering `free_boxed_int'\n"
+     "           | (16): calling `wrapped_free'\n"
+     "           |\n"
+     "           +--> `wrapped_free': events 17-18 (depth 2)\n"
      "                  |\n"
-     "                  +--> `wrapped_free': events 17-18 (depth 2)\n"
-     "                              |\n"
-     "                              | (17): entering `wrapped_free'\n"
-     "                              | (18): calling free\n"
-     "                              |\n",
+     "                  | (17): entering `wrapped_free'\n"
+     "                  | (18): calling free\n"
+     "                  |\n",
      pp_formatted_text (dc.printer));
 }
 
@@ -785,24 +767,24 @@ test_recursion (pretty_printer *event_pp)
   summary.print (&dc, true);
   ASSERT_STREQ
     ("  `factorial': events 1-2 (depth 0)\n"
-     "       |\n"
-     "       | (1): entering `factorial'\n"
-     "       | (2): calling `factorial'\n"
-     "       |\n"
-     "       +--> `factorial': events 3-4 (depth 1)\n"
-     "                 |\n"
-     "                 | (3): entering `factorial'\n"
-     "                 | (4): calling `factorial'\n"
-     "                 |\n"
-     "                 +--> `factorial': events 5-6 (depth 2)\n"
-     "                           |\n"
-     "                           | (5): entering `factorial'\n"
-     "                           | (6): calling `factorial'\n"
-     "                           |\n"
-     "                           +--> `factorial': event 7 (depth 3)\n"
-     "                                     |\n"
-     "                                     | (7): entering `factorial'\n"
-     "                                     |\n",
+     "    |\n"
+     "    | (1): entering `factorial'\n"
+     "    | (2): calling `factorial'\n"
+     "    |\n"
+     "    +--> `factorial': events 3-4 (depth 1)\n"
+     "           |\n"
+     "           | (3): entering `factorial'\n"
+     "           | (4): calling `factorial'\n"
+     "           |\n"
+     "           +--> `factorial': events 5-6 (depth 2)\n"
+     "                  |\n"
+     "                  | (5): entering `factorial'\n"
+     "                  | (6): calling `factorial'\n"
+     "                  |\n"
+     "                  +--> `factorial': event 7 (depth 3)\n"
+     "                         |\n"
+     "                         | (7): entering `factorial'\n"
+     "                         |\n",
      pp_formatted_text (dc.printer));
 }
 
-- 
1.8.5.3

